#!/usr/bin/python

#todo: Das log-file ist aktuell eher unbrauchbar, da wir ein &>> brauchen, damit
# alles in eine Datei geschrieben wird. ggf. schreiben wir in mehre Dateien die
# Logs

#todo: wie bekommen wir fehler bei einem systemaufruf raus?

import sys
import os

from optparse import OptionParser # http://docs.python.org/lib/module-optparse.html

from Lang import *

import urllib2 # help to find a mirror for the freepascal package


DEBUG = 0 #dep use options.debug
VERSION = "2006.1"

opt = {}

# supported distributions
DIST_FEDORA = 0
DIST_UBUNTU = 1
DIST_FREEBSD = 2
DIST_SUSE = 3
DIST_NONE = 4

# path is not allowed to be used
FORBIDDEN_PATHS = ("/home","/usr")

# path and all sub directories are not allowed
STRICT_FORBIDDEN_PATHS = ("/","/etc","/var","/root","/boot","/proc","/sys","/bin","/dev")

####
# Content
####
# Main
# GUI
# Installer
# Wizard
####

#############################################
# Main
#############################################	
def loadDefaults():	
	opt['debug'] = DEBUG # debug mode, testing purpose only
	opt['install'] = 1 # installation scheduled
	opt['lang'] = 'de' # language
	opt['register'] = 0 # search path registration scheduled
	opt['dist'] = DIST_NONE # distribution
	opt['path'] = '/usr/local/dglsdk/' # installation path (needs install)
	opt['fpc'] = 0 # fpc install scheduled
	#opt['gui'] = 0
	opt['remove'] = 0
	opt['compile'] = 0

# load defaults for an express installation
def loadExpress():
	setPath("/usr/local/dglsdk/")
	setFreepascal(1)
	setRegister(1)
	setCompile(1)
	opt['install'] = 1

# check and extract arguments
def checkArgs(args):
	# options
	parser = OptionParser(usage="%prog [--install]", version="DGLSDK "+VERSION)
	parser.add_option("-i", "--install", action="store_true", dest="install", help=i18n("args_install_help"), default="false")
	parser.add_option("-r", "--register-only", action="store_true", dest="register", help=i18n("args_register_help"), default="false")
	parser.add_option("-d", "--debug", dest="debug", action="store_true", help=i18n("args_debug_help"), default="false")
	parser.add_option("-l", "--lang", dest="language", action="store", help=i18n("args_lang_help"), metavar="LANG", default="de")

	(options,args) = parser.parse_args()

	# argument handler
	if options.debug:
		print options
	
	if (options.install == 1 and options.register == 1):
		print i18n("args_exclusive")
		sys.exit(1)
		return 0
	if not (options.install == 1 or options.register == 1):
		print i18n("args_tooless")
		sys.exit(1)
		return 0
		
	# installer style
	if options.install == 1:
		opt['install'] = 1
	if options.register == 1:
		opt['register'] = 1
	if options.debug == 1:
		opt['debug'] = 1
		DEBUG = 1
		
	return 1
		
# get distribution text for plan
def getDistributionPlan():
	if opt['dist'] == DIST_NONE:
		return i18n("distplan_none")
	elif opt['dist'] == DIST_FEDORA:
		return i18n("distplan_fedora")
	elif opt['dist'] == DIST_UBUNTU:
		return i18n("distplan_ubuntu")
	elif opt['dist'] == DIST_FREEBSD:
		return i18n("distplan_freebsd")
	elif opt['dist'] == DIST_SUSE:
		return i18n("distplan_suse")
	
	print "$ FATAL unkown distribution planed. This should not be possible!"
	sys.exit(1)

#############################################
# GUI
#############################################
#
# UserInput_Bool	Asking for a y/n
# UserInput_Number	Asking for a number from a range
# UserInput_String	Asking for a string
#

def UserInput_Bool(default):
# Get a "y" or a "n" from the user; if the user press only enter the result will be default
	while True:
		if (default.lower() == 'n'):
			key = "(j/N)"
		else:
			key = "(J/n)"
		print "%s %s:" % (i18n("input_choose"),key)
		#print "oder druecke Enter fuer den Standardwert:", default
		result = sys.stdin.readline().strip() 
		if (result == ""):
			result = default
			print default
		
		if (result.lower() == "y"):return True
		if (result.lower() == "j"):return True
		if (result.lower() == "n"):return False
		
def UserInput_Number(start,end,default):
	# Ask user to choose a number
	while True:
		print "%s (%i - %i)" % (i18n("input_choose"),start,end)
		print i18n("input_default"), default
		result = sys.stdin.readline().strip() 
		if (result == ""):
			return default
		if result.isalpha():
			return default
		if (int(result) >= start) and (int(result) <= end):
			return int(result)
		
def UserInput_String(default):
	while True:
		#print i18n("input_default2")
		print i18n("input_default"), default
		
		result = sys.stdin.readline().strip() 
		if (result == ""):
			return default
		return result

		
def DownloadSourceforgeFile(filename):
	def GetWebsite(url):
		f = urllib2.urlopen(url)
		return f.read()
	def findBetween(source,startText,endText):
		result = []
		index = 0
		while True: 
			start = source.find(startText,index)
			if start != -1:
				start += len(startText)
				ende = source.find(endText,start)
				if ende != -1:
					index = ende
					result = result + [source[start:ende]]
				else:
					return result
			else:
				return result

	print "load mirrorlist - please wait"
	mirrorlistpage= GetWebsite('http://prdownloads.sourceforge.net/' + filename + '?download')
	mirrorlist = findBetween(source=mirrorlistpage,startText='?use_mirror=',endText='>')

	mirrorindex = -1
	while (mirrorindex < 0 or mirrorindex >= len(mirrorlist)):
		index = 0
		for mirrorname in mirrorlist:
			index += 1
			print str(index) + '.)', mirrorname
		sys.stdout.write('Choose Mirror: ')
		mirrorindex = int(sys.stdin.readline().strip()) -1
	mirrorname = mirrorlist[mirrorindex]

	fpcDownloadPageName = "http://prdownloads.sourceforge.net/" + filename + "?use_mirror=" + mirrorname

	print 'visit', fpcDownloadPageName
	fpcDownloadPage = GetWebsite(fpcDownloadPageName)
	fpcDownloadName = findBetween(source=fpcDownloadPage,startText='<META HTTP-EQUIV="refresh" content="5; URL=',endText='">')[0]
	
	print "download file", fpcDownloadName
	os.system("wget " + fpcDownloadName)# TODO nicht relativen Pfad verwenden

#############################################
# Installer
#############################################
# USE THESE
#
# installSDK		installs all header, samples and SDK-Stuff
# installDist		installs all needed packages for a distribution, calling subroutine
# installRegister	register path to fpc
# installUninstaller	creates a uninstaller
#
# DO NOT USE DIRECTLY, use installDist:
#
# installFedora		fedora package installation
# installUbunutu	ubuntu package installation
# installFreeBSD	freebsd package installation
#

# removed the old sdk from disk
# todo: check if rm was successfully
def installRemove():
	if not opt['remove']:
		return 1
			
	print "* "+i18n("action_remove")
	
	if DEBUG:
		print "$ rm -fr "+opt['path']
		return 1
	else:
		os.system("rm -fr "+opt['path'])
		return 1

# copy sdk files to target directory
# todo: check if copy was successfull
def installSDK():
	if not opt['install']:
		return 1
		
	print "* "+i18n("action_installSDK")
	
	if DEBUG:
		print "$ mkdir "+opt['path']
		print "$ cp -R ./header "+opt['path']+" &> "+opt['path']+"install.log"
		print "$ cp -R ./samples "+opt['path']+" &> "+opt['path']+"install.log"
		print "$ chmod -R 755 "+opt['path']+" &> "+opt['path']+"install.log"
		return 1
	else:
		# create folders
		os.system("mkdir "+opt['path'])
	
		# copy files
		os.system("cp -R ./header "+opt['path']+" &> "+opt['path']+"install.log")
		os.system("cp -R ./samples "+opt['path']+" &> "+opt['path']+"install.log")
		os.system("chmod -R 755 "+opt['path']+" &> "+opt['path']+"install.log")
		return 1

# decide which distrubtion shall be used and start customize installation
def installDistribution():
	print "* "+i18n("action_dist")+getDistributionPlan()
	if opt['dist'] == DIST_FEDORA:
		return distSetupFedora()
	if opt['dist'] == DIST_UBUNTU:
		return distSetupUbuntu()
	if opt['dist'] == DIST_FREEBSD:
		return distSetupFreeBSD()
	if opt['dist'] == DIST_SUSE:
		return distSetupSuSE()

# add headers to search path		
def installRegister():
	print "* "+i18n("action_register")
	
	# todo: Crap, breaks GUI
	if not checkForFreepascal():
		print "$ FATAL: /etc/fpc.cfg should exist, but it does not!"
		return 0
	if DEBUG:
		print "$ installRegister()"
		return 1
	else:
		f = open("/etc/fpc.cfg", "r")
		cfg = f.read()
		if cfg.find("# DGLSDK") == -1:
			os.system('echo "# ----------------" >> /etc/fpc.cfg')
			os.system('echo "# DGLSDK" >> /etc/fpc.cfg')
			os.system('echo "# ----------------" >> /etc/fpc.cfg')
			os.system('echo "-Fu/usr/local/dglsdk/header" >> /etc/fpc.cfg')
		f.close()
		return 1

# compile headers	
def installCompile():
	print "* "+i18n("action_compile")
	if DEBUG:
		print "$ "+opt['path']+"header/rebuild.sh &> "+opt['path']+"install.log"
		return 1
	else:
		os.system(opt['path']+"header/rebuild.sh &> "+opt['path']+"install.log")
		return 1
		
# Generates a small shell script for deinstalling the sdk from harddisk
def installUninstaller():
	print "* "+i18n("action_uninstaller")
	
	if DEBUG:
		return 1
	else:
		f=open(opt['path']+"uninstall.sh","w")
		f.write("#!/bin/sh\n")
		f.write("# This script helps to deinstall the DGLSDK. Please notice, it will only remove the SDK and not the pakages installed by the system.\n")
	
		#todo: this is crap. We must check if the parameter is really uninstall!
		f.write("if [ $# -ne 1 ]; then\n echo \"Please use the option --uninstall in order to deinstall the SDK\"!\nexit 1\nfi\n\n")
	
		f.write("rm -fr "+opt['path'])
		f.close()
		os.system("chmod 700 "+opt['path']+"uninstall.sh")
		return 1

def distSetupFedora():
	packages = "SDL SDL-devel SDL_image SDL_image-devel SDL_net SDL_net-devel SDL_mixer SDL_mixer-devel SDL_ttf SDL_ttf-devel SDL_gfx SDL_gfx-devel smpeg smpeg-devel"
	
	if opt['fpc']:
		packages += "fpc fpc-doc"

	if DEBUG:
		print "$ Dist Fedora yum update"
		print "$ yum -y install "+packages+" &> "+opt['path']+"install.log"
		return 1
	else:
		os.system("yum -y install "+packages+" &> "+opt['path']+"install.log")
		return 1
	
def distSetupUbuntu():
	packages = "libsdl1.2debian libsdl1.2debian-oss libsdl-image1.2 libsdl-mixer1.2 libsdl-net1.2 libsdl-ttf2.0-0 libsmpeg0"
	dev_packages = "libsdl1.2-dev libsdl-image1.2-dev libsdl-mixer1.2-dev libsdl-net1.2-dev libsdl-ttf2.0-dev libsmpeg-dev"
	# Hint libsdl-ttf2.0-0 is stable
	if DEBUG:
		print "$ Dist Ubunutu apt-get"
		print "$ apt-get install " + packages + " " + dev_packages
		return 1
	else:
		os.system("apt-get install " + packages + " " + dev_packages)
		return 1

def distSetupFreeBSD():# FreeBSD 5.4
	packages = "sdl sdl_image sdl_mixer sdl_net sdl_ttf sdl_gfx smpeg"

	if DEBUG:
		print "$ Dist FreeBSD pkg_add"
		print "$ pkg_add -rv" + packages
		return 1
	else:
		os.system("pkg_add -rv" + packages)
		return 1

def distSetupSuSE():
	# todo
	print "N/A yet"
	
def checkForSDK():
	return os.path.exists(opt['path'])

	
def checkForFreepascal():
	return os.path.exists("/etc/fpc.cfg")

#############################################
# Wizards
#############################################
def displayWizard():
	print "Welche Installationvariante wuenschen Sie?"
	print
	print "* 1. Express (Empfohlen)"
	print "* 2. Angepasst"
	print "* 3. "+i18n("cancle")
	print "-"*30
	q1 = UserInput_Number(1,3,1)
	
	# Express installation, just a few questions
	if (q1 == 1):
		# ask distribution
		opt['dist'] = chooseDistribution()
		
		if opt['dist'] != DIST_NONE:
			if chooseFreepascal():
				setFreepascal(1)
				setRegister(1)
				setCompile(1)
		else: 
			setFreepascal(0)
			setRegister(0)
			setCompile(0)
			
	# Custom installation, more options
	if (q1 == 2):
		displayAdvancedWizard()
		
	# cancle
	if (q1 == 3):
		sys.exit(0);
		
def displayAdvancedWizard():
	ready = 0
	while not ready:
		# determinate strings
		if opt['fpc']:
			fpc_install = 'installieren'
		else:
			fpc_install = 'nicht installieren'
			
		if opt['register']:
			fpc_register = 'Suchpfade eintragen'
		else:
			fpc_register = 'Keine Suchpfade eintragen'
			
		print "-"*30
		print "Welche Einstellung, wollen Sie anpassen?"
		print
		print "* 1. Distribution waehlen"
		print "  -  %s" % (getDistributionPlan())
		print "* 2. Installation von Freepascal"
		print "  -  %s" % (fpc_install)
		print "  -  %s" % (fpc_register)
		#print "* 3. Pfad waehlen (%s)" % opt['path']
		print "* (%s)" % opt['path']
		print "*"*30
		print "* 5. Installation beginnen"
		print "* 0.",i18n("cancle")
		
		a = UserInput_Number(0,9,5)
		if (a == 1):
			dist = chooseDistribution()
			setDistribution(dist)
			
		if (a == 2):
			r1 = chooseFreepascal()
			if r1:
				setFreepascal(r1)				
				r2 = chooseRegisterFPC()
				setRegister(r2);
			else:
				setFreepascal(False)

#		if (a == 3):
#			opt['path'] = choosePath()
			
		if (a == 5):
			# check
			ready = 1
				
		if (a == 0):
			sys.exit(0)
			
	return 1
		
def acceptInstall():
	if checkForSDK():
		chooseRemove()
		
	showOptions()
	print "-"*30	
	print "Folgende Aktionen sind auf Ihrem System geplant:"
	print
	if opt['remove']:
		print "* Alte Version der SDK entfernen"
	if opt['dist'] != DIST_NONE:
		print "* Anpassungen fuer "+getDistributionPlan()
	if opt['fpc']:
		print "* Installation von Freepascal"
	if opt['register']:
		print "* DGLSDK in Suchpfade eintragen"
	if opt['compile']:
		print "* Header kompilieren"
	if opt['install']:
		print "* Installation der DGLSDK nach "+opt['path']
	print "-"*30
	print "Wenn Sie mit J antworten, beginnt der Vorgang"
	return UserInput_Bool("J")
	
# todo: check return values for errors
def doInstall():	
	print i18n("install_wait")
	
	installRemove()
	installSDK()
	installDistribution()
	installRegister()
	installCompile()
	installUninstaller()

def setFreepascal(action):
	if action:
		opt['fpc'] = 1
	else:
		opt['fpc'] = 0
		setRegister(0)
		setCompile(0)
		
def setRegister(action):
	opt['register'] = action
	
def setCompile(action):
	opt['compile'] = action
		
def setDistribution(id):
	opt['dist'] = id
	if (id == DIST_NONE):
		setFreepascal(0)
		
def setPath(value):
	# correct path
	#path = str(value)
	path = value.lower()
	
	if not path.endswith("/"):
		path = path + "/"

	for d in STRICT_FORBIDDEN_PATHS:
		if d == path:
			print "#"*30
			print "Warnung! Der Pfad wurde aus Sicherheitsgruenden abgelehnt!"
			print "#"*30
			opt['path'] = '/usr/local/dglsdk/'
			return 0
	#for d in FORBIDDEN_PATHS:
	#	if not path.find(d) == 0:
	#		print "#"*30
	#		print "Warnung! Der Pfad wurde aus Sicherheitsgruenden abgelehnt!"
	#		print "#"*30
	#		opt['path'] = '/usr/local/dglsdk/'
	#		return 0
			
	# denied paths
	opt['path'] = path
	return 1
	
def setRemove(value):
	opt['remove'] = value
		
def chooseRemove():
	print "-"*30
	print "Im Zielverzeichnis wurde bereits eine Installation der DGLSDK gefunden. Soll diese entfernt werden?"
	print
	print "* j Die alte DGLSDK unter "+opt['path']+" wird komplett geloescht."
	print "* n abbruch"
	if not UserInput_Bool("n"):
		sys.exit(0)
	else:
		setRemove(1)
		
def chooseDistribution():
	print "-"*30	
	print i18n("chooseDist_quest")
	print
	print "* 1. Fedora Core (%s)" % (i18n("chooseDist_FedoraTest"))
	print "* 2. Ubuntu (%s)" % (i18n("chooseDist_UbuntuTest"))
	print "* 3. FreeBSD 5.4 (%s)" % (i18n("chooseDist_FreebsdTest"))
	print "* 4. Open SuSE (%s)" % (i18n("chooseDist_Suse"))
	print "* 5.",i18n("chooseDist_Other")
	print "* 6.",i18n("cancle")
	print "-"*30
	
	a = UserInput_Number(1,6,6)
	if (a == 6):
		sys.exit(0)
	return a-1
	
def chooseFreepascal():
	print "-"*30
	print "Die SDK ist fuer Freepascal ausgelegt. Soll der Installer sich um eine Installation kuemmern?"
	print
	print "* j Der Installer versucht ueber den guenstigsten Weg FPC zu installieren"
	print "* n Es wird keine FPC unterstuetzt"
	print "-"*30

	return UserInput_Bool("n")

def chooseRegisterFPC():
	print "-"*30
	print "Soll die SDK die Header automatisch in die Suchpfade von FPC eintragen?"
	print
	print "* j Der Installer fuegt (sofern noetig) einen neuen Suchpfad an"
	print "* n Es wird kein Suchpfad auf die Header gesetzt"
	print "-"*30

	return UserInput_Bool("j")

def choosePath():
	user = os.getlogin()
	ready = 0
	while not ready:
		print "-"*30
		print i18n("choosePath_quest")
		print "1. /usr/local/dglsdk/"
		print "2. /home/"+user+"/dglsdk/"
		print "3. benutzerdefiniert	"	

		print "-"*30
		a = UserInput_Number(1,3,1)
		
		if a == 1:
			setPath("/usr/local/dglsdk/")
			ready = 1
		if a == 2:
			setPath("/home/"+user+"/dglsdk/")
			ready = 1
		if a == 3:
			path = UserInput_String("/usr/local/dglsdk/")
			setPath(path)
			ready = 1
	
	return opt['path']
	#return UserInput_String("/usr/local/dglsdk")

#############################################
# Text Installer Messages
#############################################	
#
# showHeader		just showing the typical header of the installer
# showArgs			show all avaible arguments
# showOption		in debug mode, showing the current options
#
def showHeader():
	print "-"*70
	print "DGLSDK Linux Edition .:. "+VERSION
	print "http://www.delphigl.com/ .::::. Copyright 2005-2006 by the DGL Community"
	print "-"*70
	
def showSuccess():
	print "-"*30
	print "Die Installation wurde beendet."
	print "Entwickler unter Linux sind bei DGL momentan rar. Wenn Du Dich also einmal einsam fuehlst, nimm Kontakt mit"
	print "uns im Forum auf! Wir freuen uns ueber jeden neuen Zugang! :)\n"
	print "Die DGL-Community wuenscht Dir bei der Entwicklung unter Linux viel Erfolg. Bei Fragen rund um OpenGL wird man Dir"
	print "* im Forum weiterhelfen koennen (http://www.delphigl.com/forum/)"
	print "* im Wiki Auskunft geben (http://wiki.delphigl.com/)"
	print "Viel Erfolg!"

def showOptions():
	if opt['debug']:
		print "-"*30;
		print opt;
