program Fontexample;

{$IFDEF FPC}
  {$MODE DELPHI}
{$ELSE}
  {$APPTYPE CONSOLE}
{$ENDIF}

{******************************************************************}
(*
  Released as part of the DGLSDK
  Visit us @ http://www.delphigl.com
  Maintained by Jonas Scholz (i0n0s)
  jonasscholz@web.de
-------------------------------------------------------------------
  License
  -------
  Copyright (C) 2006 www.delphigl.com

  This license applies to everything on www.delphigl.com, except where otherwise noted.

  This software is provided 'as-is', without any express or implied warranty.  In no event will the authors 
  be held liable for any damages arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose, including commercial applications, 
  and to alter it and redistribute it freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not claim that you wrote the original 
  software. If you use this software in a product, an acknowledgment in the product documentation would be 
  appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Description
  -----------
  This sample try to demonstrate how to use easySDLFont.

  Requirements
  ------------
  - SDL 1.2 (http://www.libsdl.org/download-1.2.php or your distribution)
  - Freepascal 2.0.0 or above (http://www.freepascal.org/download.html)
  - JEDI-SDL 1.0 (http://www.delphi-jedi.org/Jedi:TEAM_SDL_HOME)
  - DGLSDK for Linux (http://www.delphigl.com/)


  History
  -------
  2006-05-01 Added licence (JS)

  Contact
  -------
  We created this source code in our spare time. If you find a bug or just
  wanna say hello, feel free to write to the contributors: 


  JS
    Jonas Scholz (i0n0s)
    email : jonasscholz@web.de

*******************************************************************************)


uses
  dglOpenGL,

  SDL,
  SDL_TTF,
  easySDL,
  easySDLFont;

{$I ../dglsdk.inc}

type
  TMyProgram = class(TEasySDL)
    procedure DrawScene;override;
  end;

var
  MyProgram :TMyProgram;
  Font1, Font2, Font3: TFont;
  Color: TSDL_Color;

procedure TMyProgram.DrawScene;
begin
  // Screen- und Tiefenbuffer bereinigen
  glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT );

  glLoadIdentity;

  Font3.Draw('DGL - Connection people', 34, 316);
  Font2.Draw('Vertrauen ist gut, DGL ist besser', 335, 94);
  Font3.Draw('DGL - und du wirst Augen machen', 174, 191);
  Font2.Draw('Wer DGL hat, hat''s leichter', 204, 284);
  Font3.Draw('DGL - Auen gut, innen besser', 19, 71);
  Font2.Draw('DGL - schlichtweg fantastisch', 258, 165);
  Font3.Draw('DGL - Warum auch nicht?', 78, 386);
  Font2.Draw('DGL gut, alles gut', 433, 423);
  Font3.Draw('Mit DGL wei man, was man hat', 102, 138);
  Font2.Draw('DGL fngt da an, wo andere aufhren', 258, 49);
  Font3.Draw('Tglich DGL und du fhlst dich wohl', 143, 10);
  Font2.Draw('Nimm DGL, dann klapt''s auch mit dem Nachbarn', 14, 121);
  Font3.Draw('Nichts bewegt Sie wie DGL', 220, 354);
  Font2.Draw('DGL bringt Leben in den Computer', 328, 335);
  Font3.Draw('Ohne DGL fehlt dir was', 40, 438);
  Font2.Draw('DGL aktiviert Abwehrkrfte', 234, 455);
  Font3.Draw('DGL kriegt auch Dich', 1, 35);

  Font1.Draw('visit www.delphigl.com', 50, 210);
end;

begin
  MyProgram := TMyProgram.Create('www.delphigl.com .:. easySDLFontexample');
  MyProgram.Start;

  Color.r:=$FF;
  Color.g:=$8D;
  Color.b:=$1D;
  Color.unused:=0;

  Font1 := TFont.Create(DGLSDK_DATA+'fonts/steelout.ttf', 70, Color, TTF_STYLE_UNDERLINE);

  Color.r:=$D4;
  Color.g:=$E8;
  Color.b:=$FE;

  Font2 := TFont.Create(DGLSDK_DATA+'fonts/dreamorphans.ttf', 21, Color, 0);

  Color.r:=$42;
  Color.g:=$4A;
  Color.b:=$63;

  Font3 := TFont.Create(DGLSDK_DATA+'fonts/goodfish.ttf', 22, Color, 0);

  glClearColor(($29)/255, ($18)/255, ($52)/255, 0.0);

  glMatrixMode(GL_PROJECTION);  // Change Matrix Mode to Projection
  glLoadIdentity();             // Reset View
  glOrtho(0, 640, 0, 480, 0, 100);
  glMatrixMode(GL_MODELVIEW);   // Change Projection to Matrix Mode
  glLoadIdentity;

  MyProgram.Loop;
  MyProgram.Stop;
end.
