program particeldemo;

{$IFDEF FPC}
  {$MODE DELPHI}
{$ELSE}
  {$APPTYPE CONSOLE}
{$ENDIF}

{******************************************************************}
(*
  Released as part of the DGLSDK
  Visit us @ http://www.delphigl.com
  Maintained by Jonas Scholz (i0n0s)
  jonasscholz@web.de
-------------------------------------------------------------------
  License
  -------
  Copyright (C) 2006 www.delphigl.com

  This license applies to everything on www.delphigl.com, except where otherwise noted.

  This software is provided 'as-is', without any express or implied warranty.  In no event will the authors 
  be held liable for any damages arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose, including commercial applications, 
  and to alter it and redistribute it freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not claim that you wrote the original 
  software. If you use this software in a product, an acknowledgment in the product documentation would be 
  appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Description
  -----------
  This sample try to demonstrate how to use the arb point sprite. A point sprite might be usefull for a particle system.
	Instead of using several quads with the particle texture, you can define the position with a point. This should also save 
	bandwidth of the pipeline allowing more particles ;)

  Requirements
  ------------
  - SDL 1.2 (http://www.libsdl.org/download-1.2.php or your distribution)
  - Freepascal 2.0.0 or above (http://www.freepascal.org/download.html)
  - JEDI-SDL 1.0 (http://www.delphi-jedi.org/Jedi:TEAM_SDL_HOME)
  - DGLSDK for Linux (http://www.delphigl.com/)


  History
  -------
  2006-05-01 Added licence (JS)

  Contact
  -------
  We created this source code in our spare time. If you find a bug or just
  wanna say hello, feel free to write to the contributors: 


  JS
    Jonas Scholz (i0n0s)
    email : jonasscholz@web.de

=======
(*
  Released as part of the DGLSDK
  Visit us @ http://www.delphigl.com
  Maintained by Jonas Scholz (i0n0s)
  jonasscholz@web.de
-------------------------------------------------------------------
  License
  -------
  Copyright (C) 2006 www.delphigl.com

  This license applies to everything on www.delphigl.com, except where otherwise noted.

  This software is provided 'as-is', without any express or implied warranty.  In no event will the authors 
  be held liable for any damages arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose, including commercial applications, 
  and to alter it and redistribute it freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not claim that you wrote the original 
  software. If you use this software in a product, an acknowledgment in the product documentation would be 
  appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Description
  -----------
  This sample show a little particleengine based on the tutorial particle1 by Lithander, which can be found here:
  http://wiki.delphigl.com/index.php/Tutorial_Partikel1
  As an extension the samplecode is able to use vertexarrays as well as vertexbufferobjects to improve the speed of the code.

  Requirements
  ------------
  - SDL 1.2 (http://www.libsdl.org/download-1.2.php or your distribution)
  - Freepascal 2.0.0 or above (http://www.freepascal.org/download.html)
  - JEDI-SDL 1.0 (http://www.delphi-jedi.org/Jedi:TEAM_SDL_HOME)
  - DGLSDK for Linux (http://www.delphigl.com/)


  History
  -------
  2006-05-01 Added licence (JS)

  Contact
  -------
  We created this source code in our spare time. If you find a bug or just
  wanna say hello, feel free to write to the contributors: 


  JS
    Jonas Scholz (i0n0s)
    email : jonasscholz@web.de

*******************************************************************************)

uses
  SDL,
  dglOpenGL,
  easySDL,
  easySDLTextures,
  easySDLFont,
  partikelsystem,
  sysutils;

{$I ../dglsdk.inc}

type
  TMyProgram = class(TEasySDL)
    procedure DrawScene; override;
  end;

var
    MyProgram   : TMyProgram;
    FPSCounter  : TFont;
    Color       : TSDL_Color;
    Fire, Fire2 : TFire;

//----------------------------------------------------------------------------
// Zeichnen der Szene
//----------------------------------------------------------------------------
procedure TMyProgram.DrawScene;
begin
  // Screen- und Tiefenbuffer bereinigen
  glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT );

  glMatrixMode(GL_PROJECTION);  // Change Matrix Mode to Projection
  glLoadIdentity();             // Reset View
  glOrtho(0, 640, 0, 480, 0, 100);
  glMatrixMode(GL_MODELVIEW);   // Change Projection to Matrix Mode
  glLoadIdentity;

  FPSCounter.Draw(InttoStr(Round(FPS)),0,0);

  handleresize(640,480);
  glLoadIdentity;

  glTranslatef(0, 0, -6);

  glBindTexture(GL_TEXTURE_2D, 0);

  glColor3f(0,0,0);
  glBegin(GL_QUADS);
    glNormal3f( 0.0, 0.0, 1.0);
    glVertex3f( 4, 4, 0);
    glVertex3f(-4, 4, 0);
    glVertex3f(-4,-4, 0);
    glVertex3f( 4,-4, 0);
  glEnd(); 

  glEnable(GL_BLEND);
  glDisable(GL_DEPTH_TEST);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE);

  glTranslatef(-1, 0, 2);
  Fire.Render;

  glTranslatef( 2, 0, 0);
  Fire2.Render;

  glDisable(GL_BLEND);
  glEnable(GL_DEPTH_TEST);
end;

(******************************************************************************)
(******************************************************************************)
//  Hauptprogramm
(******************************************************************************)
(******************************************************************************)

begin
  randomize;
  // Initalisierung
  MyProgram := TMyProgram.Create('www.delphigl.com .:. particelexample');
  MyProgram.Start;

  ReadImplementationProperties;

  Color.r:=255;
  Color.g:=255;
  Color.b:=255;
  Color.unused:=0;

  FPSCounter := TFont.Create(DGLSDK_DATA+'fonts/monofont.ttf',16, Color, 0);

  Fire:=TFire.Create(450, Textures.Load(DGLSDK_DATA+'gfx/fire.tga', 'fire'));
  Fire2:=TFire.Create(450, Textures.Texture['fire']);

  MyProgram.Loop;
  MyProgram.Stop;
end.
