program template;

{$IFDEF FPC}
  {$MODE DELPHI}
{$ELSE}
  {$APPTYPE CONSOLE}
{$ENDIF}

{******************************************************************}
(*
  Released as part of the DGLSDK
  Visit us @ http://www.delphigl.com
  Maintained by Jonas Scholz (i0n0s)
  jonasscholz@web.de
-------------------------------------------------------------------
  License
  -------
  Copyright (C) 2006 www.delphigl.com

  This license applies to everything on www.delphigl.com, except where otherwise noted.

  This software is provided 'as-is', without any express or implied warranty.  In no event will the authors 
  be held liable for any damages arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose, including commercial applications, 
  and to alter it and redistribute it freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not claim that you wrote the original 
  software. If you use this software in a product, an acknowledgment in the product documentation would be 
  appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Description
  -----------
  Simple template for the easySDL-framework

  Requirements
  ------------
  - SDL 1.2 (http://www.libsdl.org/download-1.2.php or your distribution)
  - Freepascal 2.0.0 or above (http://www.freepascal.org/download.html)
  - JEDI-SDL 1.0 (http://www.delphi-jedi.org/Jedi:TEAM_SDL_HOME)
  - DGLSDK for Linux (http://www.delphigl.com/)


  History
  -------
  2006-05-01 Added licence (JS)

  Contact
  -------
  We created this source code in our spare time. If you find a bug or just
  wanna say hello, feel free to write to the contributors: 


  JS
    Jonas Scholz (i0n0s)
    email : jonasscholz@web.de

*******************************************************************************)

uses
  dglOpenGL,
  SDL,
  easySDL,
  easySDLFont,
  easySDLTextures,
  SysUtils;

{$I ../dglsdk.inc}

type
  TMyProgram = class(TEasySDL)
    FPSFont: TFont;
    procedure DrawScene; override;
  end;

var
    MyProgram   : TMyProgram;

//----------------------------------------------------------------------------
// Zeichnen der Szene
//----------------------------------------------------------------------------
procedure TMyProgram.DrawScene;
begin
  glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT );
  glMatrixMode(GL_PROJECTION);  // Change Matrix Mode to Projection
  glLoadIdentity();             // Reset View
    glOrtho(0, 640, 0, 480, 0, 100);
  glMatrixMode(GL_MODELVIEW);   // Change Projection to Matrix Mode
  glLoadIdentity;
    FPSFont.Draw(InttoStr(Round(FPS)),0,0);
    handleresize(640,480);
  glLoadIdentity;

  glTranslatef(0,0,-6);
  Textures.Bind('Wiki');
  glColor3f(1,1,1);
  glBegin(GL_QUADS);
    glTexCoord2f(0,0); glVertex3f(-1,-1, 0);
    glTexCoord2f(0,1); glVertex3f(-1, 1, 0);
    glTexCoord2f(1,1); glVertex3f( 1, 1, 0);
    glTexCoord2f(1,0); glVertex3f( 1,-1, 0);
  glEnd();
end;

(******************************************************************************)
(******************************************************************************)
//  Hauptprogramm
(******************************************************************************)
(******************************************************************************)
var Color: TSDL_Color;

begin
  // Initalisierung
  MyProgram := TMyProgram.Create('www.delphigl.com .:. Template');
  MyProgram.Start;

  Color.r:=255;
  Color.g:=255;
  Color.b:=255;
  Color.unused:=0;

  MyProgram.FPSFont:=TFont.Create(DGLSDK_DATA+'fonts/monofont.ttf',16, Color, 0);
  Textures.Load(DGLSDK_DATA+'gfx/wiki.jpg','Wiki');

  MyProgram.Loop;
  MyProgram.Stop;
end.
