//Die 3 Lichtpositionen, uniform da im Programm bergeben.
uniform vec4  LightPos0,LightPos1,LightPos2;
//Verwendete Textur. Die erste aktive Textur wird automatisch von OpenGL bergeben.
uniform sampler2D texSampler;
//Vertexposition, wird durch den Vertexshader bergeben.
varying vec4 vpos;


void main(void)
{
  float d;
  vec4 MainColor;
  d             = 1.0 - distance(LightPos0,vpos)/7.0;
  //Berechnen die Farbestrke Rot des Pixels durch die erste Lichtquelle.
  MainColor     = vec4(1.0,0.0,0.0,0.0)*d;
  d             = 1.0 - distance(LightPos1,vpos)/7.0;
  //Berechnen die Farbestrke Grn des Pixels durch die zweite Lichtquelle.
  //Das += beachten, der Wert wird dazu addiert.
  MainColor    += vec4(0.0,1.0,0.0,0.0)*d;
  d             = 1.0 - distance(LightPos2,vpos)/7.0;
  MainColor    += vec4(0.0,0.0,1.0,0.0)*d;
  //Farbe des Pixels insgesamt. Besteht aus der Farbe der Textur multipliziert mit der Farbstrke
  gl_FragColor  = texture2D(texSampler, vec2(gl_TexCoord[0])) * MainColor;
}