program sample_sdl_thread;

{$IFDEF FPC}
  {$MODE DELPHI}
{$ELSE}
  {$APPTYPE Console}
{$ENDIF}

{******************************************************************}
(*
  Released as part of the dglsdk for linux
  Visit us @ http://www.delphigl.com
  Maintained by Florian Sievert (Phobeus)
  Phobeus@DelphiGL.com
-------------------------------------------------------------------
  License
  -------
  Copyright (C) 2005 www.delphigl.com

  This license applies to everything on www.delphigl.com, except where otherwise noted.

  This software is provided 'as-is', without any express or implied warranty.  In no event will the authors
  be held liable for any damages arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose, including commercial applications,
  and to alter it and redistribute it freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not claim that you wrote the original
  software. If you use this software in a product, an acknowledgment in the product documentation would be
  appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Description
  -----------
  This small demo shows how to create and use a simple SDL_Thread. The main application create a thread and wait until the thread
  finished its work. The thread itself just wait also some seconds. Notice that this sample just demonstrate how to use the functions.
  It does not clearly shows why threads are used, because the main thread starts to wait right after the creation of the thread function.
  In a game both thread might run in a loop and wait for further events.

  Requirements
  ------------
  - SDL 1.2 (http://www.libsdl.org/download-1.2.php or your distribution)
  - Freepascal 2.0.0 or above (http://www.freepascal.org/download.html)
  - JEDI-SDL 1.0 (http://www.delphi-jedi.org/Jedi:TEAM_SDL_HOME)
  - DGLSDK for Linux (http://www.delphigl.com/)

  History
  -------
  2005-08-15 Created (FS)


  Contact
  -------
  We created this source code in our spare time. If you find a bug or just
  wanna say hello, feel free to write to the contributors:

  FS
    Florian Sievert (Phobeus)
    email : Phobeus@DelphiGL.com
    Visit: http://www.delphigl.com

*******************************************************************************)

uses	
  SDL;

var
  thread: PSDL_Thread;
  returnValue: Integer;

function thread_func(): Integer;
begin
  // do threading here
  WriteLn('Start Thread');
  SDL_Delay(5000);
  WriteLn('End Thread');

  result := 1; // thread leaves and return this value
end;

begin
  returnValue := 0;
  thread := SDL_CreateThread(@thread_func, NIL);

  SDL_WaitThread(thread, returnValue);
  WriteLn('Thread returns code');

  SDL_Quit;
  WriteLn('ByeBye ;)');
end.
