program sample_sdl_thread;

{$IFDEF FPC}
  {$MODE DELPHI}
{$ELSE}
  {$APPTYPE Console}
{$ENDIF}

{******************************************************************}
(*
  Released as part of the DGLSDK
  Visit us @ http://www.delphigl.com
  Maintained by Florian Sievert (Phobeus)
  Phobeus@DelphiGL.com
-------------------------------------------------------------------
  License
  -------
  Copyright (C) 2005 www.delphigl.com

  This license applies to everything on www.delphigl.com, except where otherwise noted.

  This software is provided 'as-is', without any express or implied warranty.  In no event will the authors 
  be held liable for any damages arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose, including commercial applications, 
  and to alter it and redistribute it freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not claim that you wrote the original 
  software. If you use this software in a product, an acknowledgment in the product documentation would be 
  appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Description
  -----------
  This small demo shows how to create and use a simple SDL_Thread. The main application create a thread and wait until the thread
  finished its work. The thread itself just wait also some seconds. Notice that this sample just demonstrate how to use the functions.
  It does not clearly shows why threads are used, because the main thread starts to wait right after the creation of the thread function.
  In a game both thread might run in a loop and wait for further events.

  Requirements
  ------------
  - SDL 1.2 (http://www.libsdl.org/download-1.2.php or your distribution)
  - Freepascal 2.0.0 or above (http://www.freepascal.org/download.html)
  - JEDI-SDL 1.0 (http://www.delphi-jedi.org/Jedi:TEAM_SDL_HOME)
  - DGLSDK for Linux (http://www.delphigl.com/)
  and for people who are always in a hurry:
  - 3D opengl drivers for your graphic card (of course) ;-)


  History
  -------
  2005-08-15 Created (FS)


  Contact
  -------
  We created this source code in our spare time. If you find a bug or just
  wanna say hello, feel free to write to the contributors: 

  FS
    Florian Sievert (Phobeus)
    email : Phobeus@DelphiGL.com
    Visit: http://www.delphigl.com

*******************************************************************************)
uses
//  CRT,
  SDL;

var
  times : Integer;

function timer_func(interval:Uint32): Integer;
begin
  inc(times);
  Write('... '); Write(interval div 1000); Writeln(' seconds later');

  // result value 0 will cancel timer, SDL_RemoveTimer will do the same
  result := interval-1000;
end;

////////////////////////////////////////////////////////////////////////////////
// Aufgabe:                                                                   //
//   Trockenbungen: Wie oft und was gibt die Timerfunktion aus?              //
////////////////////////////////////////////////////////////////////////////////

begin
  // Init SDL and timer
  SDL_Init(SDL_INIT_TIMER);
  SDL_AddTimer(3000,@timer_func,nil);
  Writeln('Started');

  // just wait
  SDL_Delay(8000);

  // Release
  SDL_Quit;
  WriteLn('ByeBye ;)');
end.
