program sample_sdl_ttf; // v0.8
// WARNING! THIS FILE IS STILL UNDER CONSTRUCTION!
// SO JUST SEE THIS AS WHAT IT IS ==> A PREVIEW ;)





{$IFDEF FPC}
  {$MODE DELPHI}
{$ELSE}
  {$APPTYPE Console}  
{$ENDIF}

{******************************************************************}
(*
  Released as part of the DGLSDK
  Visit us @ http://www.delphigl.com
  Maintained by Florian Sievert (Phobeus)
  Phobeus@DelphiGL.com
-------------------------------------------------------------------
  License
  -------
  Copyright (C) 2005 www.delphigl.com

  This license applies to everything on www.delphigl.com, except where otherwise noted.

  This software is provided 'as-is', without any express or implied warranty.  In no event will the authors 
  be held liable for any damages arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose, including commercial applications, 
  and to alter it and redistribute it freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not claim that you wrote the original 
  software. If you use this software in a product, an acknowledgment in the product documentation would be 
  appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Description
  -----------


  Requirements
  ------------
  - SDL 1.2 (http://www.libsdl.org/download-1.2.php or your distribution)
  - Freepascal 2.0.0 or above (http://www.freepascal.org/download.html)
  - JEDI-SDL 1.0 (http://www.delphi-jedi.org/Jedi:TEAM_SDL_HOME)
  - DGLSDK for Linux (http://www.delphigl.com/)


  History
  -------
  2005-06-26 Created (FS)


  Contact
  -------
  We created this source code in our spare time. If you find a bug or just
  wanna say hello, feel free to write to the contributors: 

  FS
    Florian Sievert (Phobeus)
    email : Phobeus@DelphiGL.com
    Visit: http://www.delphigl.com

*******************************************************************************)

uses
//	CRT,
	SysUtils,
	
	SDL,
	SDL_Image,
	SDL_ttf,
        
	dglOpenGL;

{$I ../dglsdk.inc}

const
	WINDOW_CAPTION		=       'http://www.delphigl.com/ .:. SDL-TrueType Font Sample'; 
	WINDOW_RESIZE		=       FALSE;					// Enable user to resize window
	FULLSCREEN			=       FALSE;					// Start using fullscreen mode

	SCREEN_WIDTH		= 640;							
	SCREEN_HEIGHT		= 480;							
	SCREEN_BPP			= 32;								// screen depth

	FPS_INTERVAL		= 1000;							// calc every second FPS
	
	// TTF constants
	FONT_SIZE			=	28;
	FORECOLOR	: TSDL_Color = ( r : $FF; g : $00; b : $00; unused : 0 );
	BACKCOLOR	: TSDL_Color = ( r : $00; g : $00; b : $00; unused : 0 );

var
	// SDL video
	surface : PSDL_Surface;
	videoInfo : TSDL_VideoInfo;
	videoflags : Uint32;
	
	// textures	
	wiki : gluInt;	
	texture:gluInt;

  texcoord : array [0..3]of TGlFloat;

	// misc
	done        : Integer;                    // programm status (0 = rund, -1 abort)   
	FPSCount    : LongInt;
	
	// SDL_TTF
	font : PTTF_Font;
	x, y : gluInt;		// current position of main text
	w, h : gluInt;



//----------------------------------------------------------------------------
// quiting app - get sure everything is released
//----------------------------------------------------------------------------
procedure Quit_App;
begin
	// release ressources
	Writeln('Release Ressources...');

  // release textures
  glDeleteTextures(1,@wiki);
  glDeleteTextures(1,@texture);
    
	if (FULLSCREEN) then SDL_WM_ToggleFullScreen(surface);
	TTF_CloseFont( font );
	SDL_FreeSurface (surface) ;
	SDL_Quit;
	
	// time to say goodbye
	WriteLn('Bye Bye :)');
	Halt(0);
end;

//----------------------------------------------------------------------------
// Part of original sdl glfont demo
// help function
//----------------------------------------------------------------------------
function power_of_two( input : integer ) : integer;
var
	value : integer;
begin
	value := 1;
	while ( value < input ) do
	begin
		value := value shl 1;
	end;
	result := value;
end;

//----------------------------------------------------------------------------
// Part of original sdl glfont demo
// Surface to opengl texture, calc texture coords
//----------------------------------------------------------------------------
function SDL_GL_LoadTexture( surface : PSDL_Surface) : TGLuint;
var
	texture : TGLuint;
	w, h : integer;
	image : PSDL_Surface;
	area : TSDL_Rect;
	saved_flags : Uint32;
	saved_alpha : Uint8;
begin
	// Use the surface width and height expanded to powers of 2
	w := power_of_two( surface.w );
	h := power_of_two( surface.h );
	
	texcoord[ 0 ] := 0.0; //Min X
	texcoord[ 1 ] := 0.0; // Min Y
	texcoord[ 2 ] := surface.w / w; // Max X
	texcoord[ 3 ] := surface.h / h; // Max Y
	
	image := SDL_CreateRGBSurface(SDL_SWSURFACE,w, h,32,
	{$IFDEF IA32} (* OpenGL RGBA masks *)
	$000000FF,
	$0000FF00,
	$00FF0000,
	$FF000000
	{$ELSE}
	$FF000000,
	$00FF0000,
	$0000FF00,
	$000000FF
	{$ENDIF});
	
	if ( image = nil ) then
	begin
		result := 0;
		exit;
	end;
  
	// Save the alpha blending attributes
	saved_flags := surface.flags and ( SDL_SRCALPHA or SDL_RLEACCELOK );
	saved_alpha := surface.format.alpha;
	
	if ( ( saved_flags and SDL_SRCALPHA ) = SDL_SRCALPHA ) then
	begin
		SDL_SetAlpha( surface, 0, 0 );
	end;
	
	// Copy the surface into the GL texture image
	area.x := 0;
	area.y := 0;
	area.w := surface.w;
	area.h := surface.h;  
	SDL_BlitSurface( surface, @area, image, @area );
	
	// Restore the alpha blending attributes 
	if ( ( saved_flags and SDL_SRCALPHA ) = SDL_SRCALPHA ) then
	begin
		SDL_SetAlpha( surface, saved_flags, saved_alpha );
	end;
   
	// Create an OpenGL texture for the image
	glGenTextures( 1, @texture );
	glBindTexture( GL_TEXTURE_2D, texture );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST );
	
	glTexImage2D( GL_TEXTURE_2D,0,GL_RGBA,w, h,0,GL_RGBA,GL_UNSIGNED_BYTE, image.pixels );
	SDL_FreeSurface( image ); // No longer needed
	result := texture;
end;

procedure DrawTextTexture;
begin
	glPushAttrib( GL_ENABLE_BIT );
	glDisable( GL_DEPTH_TEST );
	glDisable( GL_CULL_FACE );
	glEnable( GL_TEXTURE_2D );

	glViewport( 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );
  	
	glMatrixMode( GL_PROJECTION );
	glPushMatrix;
		glLoadIdentity;
		glOrtho( 0.0, SCREEN_WIDTH, SCREEN_HEIGHT, 0.0, 0.0, 1.0 );
	glMatrixMode( GL_MODELVIEW );
		glLoadIdentity;
		
	// Enable alpha test to use alpha information of text
	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER,0.01);

	// Render quad for the text
  glBindTexture( GL_TEXTURE_2D, texture );
  	glBegin( GL_QUADS);
		glTexCoord2f( texcoord[0], texcoord[1] );
		glVertex2i( x, y );
		glTexCoord2f( texcoord[2], texcoord[1]);
		glVertex2i( x + w, y );
		glTexCoord2f( texcoord[2], texcoord[3] );
		glVertex2i( x + w, y + h );
		glTexCoord2f( texcoord[0], texcoord[3] );
		glVertex2i( x , y + h );
	glEnd;
		
	glDisable(GL_ALPHA_TEST);
	
	// back to 3D mode  
	glMatrixMode( GL_PROJECTION );
		glPopMatrix;
		glPopAttrib;
	glMatrixMode( GL_MODELVIEW );
end;

//----------------------------------------------------------------------------
// Draw the text on a quad
//----------------------------------------------------------------------------
procedure CreateTextTexture;
var
	screen : PSDL_Surface;
	image : PSDL_Surface;
begin
	// creating a surface with a text on it.
	image := TTF_RenderText_Shaded( font, PChar( 'DGL - die OpenGL-Community!' ), FORECOLOR, BACKCOLOR );

	// if not avaible, something went terrible wrong
	if ( image = nil ) then
	begin
		WriteLn('Could not render text!'+SDL_GetError);
		TTF_CloseFont(font);
		SDL_QUIT;
	end;

	// surface to opengl texture
	w := image.w;
	h := image.h;
	texture := SDL_GL_LoadTexture( image );
	SDL_FreeSurface( image );

	// Switch to 2D mode  
	screen := SDL_GetVideoSurface;
end;



//----------------------------------------------------------------------------
// draw the scene
//----------------------------------------------------------------------------
procedure glDrawScene;
begin
	// clear screen and depth buffer
	glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT );
	glClearColor(0.0,0.0,0.0,0.0);

	// our mini cam
	glLoadIdentity;
	glTranslatef(0,0,-5);
	
	// dgl wiki advertise ;-)
	glBindTexture(GL_TEXTURE_2D,wiki);
	glBegin(GL_QUADS);
		glTexCoord2f(0,1); glVertex3f(-0.5,-0.5,0.3);
		glTexCoord2f(1,1); glVertex3f( 0.5,-0.5,0.0);
		glTexCoord2f(1,0); glVertex3f( 0.5, 0.5,0.0);
		glTexCoord2f(0,0); glVertex3f(-0.5, 0.5,0.3);
	glEnd();
	
	// draw our text		
	DrawTextTexture;
end;

//----------------------------------------------------------------------------
// resize action
//----------------------------------------------------------------------------
function glResizeWindow( width : integer; height : integer ) : Boolean;
begin
	// prevent division by zero
	if ( height = 0 ) then height := 1;

	// refresh viewport and projection matrix
	glViewport( 0, 0, width, height );

	glMatrixMode( GL_PROJECTION );
		glLoadIdentity;
		gluPerspective( 45.0, width / height, 0.1, 1000.0 );
	glMatrixMode( GL_MODELVIEW );

	// reset world matrix
	glLoadIdentity;

	// action successfull
	result := true;
end;

//----------------------------------------------------------------------------
// timer action
//----------------------------------------------------------------------------
function glTimer( interval : UInt32; param : Pointer ) : UInt32;
begin
	SDL_WM_SetCaption(pchar( WINDOW_CAPTION + ' ['+IntToStr(FPSCount * 1000 DIV FPS_INTERVAL)+' FPS]') , nil);
	FPSCount := 0;
	Result := interval;
end;

//----------------------------------------------------------------------------
// key actions
//----------------------------------------------------------------------------
procedure glHandleKeyPress( keysym : TSDL_keysym );
begin
	case keysym.sym of
		SDLK_ESCAPE : 
		begin
			done := -1;
		end;
	end;
end;

//----------------------------------------------------------------------------
// React on program events
//----------------------------------------------------------------------------
procedure glHandleEvents;
var event : TSDL_Event;
begin
	while ( SDL_PollEvent( @event ) = 1 ) do
	begin
		case event.type_ of

		// Quit applications
		SDL_QUITEV :
		begin
			Done := -1;
		end;
		
		SDL_MOUSEBUTTONDOWN :
		begin
			// set center of text to mouse cusor
			x := event.motion.x - w div 2;
			y := event.motion.y - h div 2;
		end;

		// key was pressed
		SDL_KEYDOWN :
		begin
			glHandleKeyPress( event.key.keysym );
		end;

		// change window size
		SDL_VIDEORESIZE :
		begin
			surface := SDL_SetVideoMode( event.resize.w, event.resize.h, SCREEN_BPP, videoflags );

			if ( surface = nil ) then
			begin
				Writeln('->Surface list');
				Quit_App;
			end;
			glResizeWindow( event.resize.w, event.resize.h );
		end;
		
		end;
    end;
end;

//----------------------------------------------------------------------------
// Initialize SDL
//----------------------------------------------------------------------------
procedure Init_SDL;
begin
	// Init SDL
	WriteLn('Initalisiere SDL...');

	if ( SDL_Init( SDL_INIT_VIDEO ) < 0 ) then
	begin
		WriteLn('->Init SDL failed:'+SDL_GetError);
		Quit_App;
	end;
	
	// Get informations about graphic card
	videoInfo := SDL_GetVideoInfo^;
	if ( @videoInfo = nil ) then
	begin
		WriteLn('->Unable to detect graphc card');
		Quit_App;
	end else WriteLn('Graphic card: ', (videoInfo.video_mem DIV 1024), ' MB');

	// Initalisierung der Surface
	surface := SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, videoflags);
	if ( surface = nil ) then
	begin
		WriteLn('->Creating surface failed:'+SDL_GetError);
		Quit_App;
	end;
      
	// flags for SDL
	videoFlags := SDL_OPENGL or			// OpenGL support
					SDL_DOUBLEBUF or			// Enable Double Buffering
					SDL_HWPALETTE;				// hardware palette

	if (videoInfo.hw_available <> 0) then
	begin
		WriteLn('Hardware Surface enabled...');
		videoFlags := videoFlags or SDL_HWSURFACE;
	end
	else
	begin
		WriteLn('Software Surface enabled...');
		videoFlags := videoFlags or SDL_SWSURFACE
	end;

	// hardware support
	if ( videoInfo.blit_hw <> 0 ) then
	begin
		WriteLn('Hardware support');
		videoFlags := videoFlags or SDL_HWACCEL;
	end else WriteLn('Software support');
	      
	// setup sdl/opengl attributes
	SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
	
	if (WINDOW_RESIZE) then videoflags := videoFlags or SDL_RESIZABLE;    // Enable window resizing

	// setup window caption
	SDL_WM_SetCaption( WINDOW_CAPTION , nil);

	// Init surface
	surface := SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_OPENGL );
	if ( surface = nil ) then
	begin
		WriteLn('->OpenGL-Support for Surface failed!');
		Quit_App;
	end;
      
	// fullscreen?
	if (FULLSCREEN) then SDL_WM_ToggleFullScreen(surface);

	// Init timer
	SDL_Init(SDL_INIT_TIMER);
end;

//----------------------------------------------------------------------------
// Initialize OpenGL
//----------------------------------------------------------------------------
procedure Init_OpenGL;
begin
	// Init OpenGL
	InitOpenGL;
	ReadExtensions;

	// Give some feedback into console that might be usefull for debuggig
	WriteLn('Extensions:  '+glGetString(GL_EXTENSIONS));
	WriteLn('------');
	WriteLn('Renderer: '+glGetString(GL_RENDERER));
	WriteLn('Version: '+glGetString(GL_VERSION));
	WriteLn('Vendor:  '+glGetString(GL_VENDOR));
	
	// set up default values for state machine 
	glEnable(GL_TEXTURE_2D);									// Enable Texture mapping
	glShadeModel(GL_SMOOTH);									// Enable Smooth Shading
	glClearColor(0.0, 0.0, 0.0, 0.5);						// Clear screen with black
	glClearDepth(1.0);											// setup Depth Buffer
	glEnable(GL_DEPTH_TEST);									// Enable Depth Testing
	glDepthFunc(GL_LEQUAL);										// Setup Depth Testing
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// better interpolation
	CreateTextTexture;
end;

//----------------------------------------------------------------------------
//  Init textures
//----------------------------------------------------------------------------
procedure Init_Resource;
var tex : PSDL_Surface;
begin
	// load texture on surface and create opengl texture
	tex := IMG_Load(DGLSDK_DATA+'gfx/wiki.jpg');
	if assigned(tex) then
	begin
		glGenTextures(1, @wiki);
		glBindTexture(GL_TEXTURE_2D, wiki);

		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		
		// Warning! Some picture formats expect GL_RGB instead of GL_BGR.
		glTexImage2D(GL_TEXTURE_2D, 0, 3, tex^.w, tex^.h,0, GL_RGB, GL_UNSIGNED_BYTE, tex^.pixels);

		SDL_FreeSurface(tex);
	end;
	
	// use texture
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,wiki);
end;

(******************************************************************************)
(******************************************************************************)
//  Initialize everything needs for SDL_TTF
(******************************************************************************)
(******************************************************************************)
procedure Init_Font;
begin
	if ( TTF_Init < 0 ) then
	begin
		WriteLn('Could not initialize SDL_TTF',SDL_GetError);
		Quit_App;
	end;
  
	font := TTF_OpenFont( PChar( DGLSDK_DATA+'fonts/monofont.ttf' ), FONT_SIZE );
	if ( font = nil ) then
	begin
		WriteLn('Could not load font');
		Quit_App;
	end else WriteLn('Load font successfully.');
  
	TTF_SetFontStyle( font, 0 );
end;


(******************************************************************************)
(******************************************************************************)
//  main program
(******************************************************************************)
(******************************************************************************)
begin
	// Init program
	Writeln('Starting...');
    
	Init_SDL;
	Init_Font;
	Init_OpenGL;	
	Init_Resource;
		  
	glResizeWindow( SCREEN_WIDTH, SCREEN_HEIGHT );
     
	// Activate timer for fps calculation
	SDL_AddTimer(1000,@glTimer,nil);

	// Enter main loop
	Writeln('Start rendering...');
	while ( Done <> -1 ) do
	begin
		glHandleEvents;
		glDrawScene;

		// show framebuffer on screen
		SDL_GL_SwapBuffers;
		Inc(FPSCount);
	end;

	// get sure programm gets terminated
	Quit_App;
end.
