program sfighter;

{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}

{******************************************************************
Released as part of the DGLSDK
Visit us @ http://www.delphigl.com
Maintained by Florian Sievert (Phobeus)
Phobeus@DelphiGL.com
-------------------------------------------------------------------
License
-------
Copyright (C) 2005 www.delphigl.com

This license applies to everything on www.delphigl.com, except where otherwise noted.

This software is provided 'as-is', without any express or implied warranty. In no event will the authors
be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial applications,
and to alter it and redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must not claim that you wrote the original
software. If you use this software in a product, an acknowledgment in the product documentation would be
appreciated but is not required.
2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
3. This notice may not be removed or altered from any source distribution.

Description
-----------
Converted and extended SDL sample of Marius Andra, http://cone3d.gamedev.net. This is a simple
2D side scrolling game with a small simple framework.

Requirements
------------
- SDL 1.2 (http://www.libsdl.org/download-1.2.php or your distribution)
- Freepascal 2.0.0 or above (http://www.freepascal.org/download.html)
- JEDI-SDL 1.0 (http://www.delphi-jedi.org/Jedi:TEAM_SDL_HOME)

History
-------
2005-07-24 Created (KidPaddle)

Contact
-------
We created this source code in our spare time. If you find a bug or just
wanna say hello, feel free to write to the contributors:

Thomas Seban (KidPaddle)
email : KidPaddle@seban.com
Visit: http://www.delphigl.com

*******************************************************************************

  This is a extened version of a converted sample of a c++ SDL example.
  Part of code is taken from Marius Andra and the credits for the sprites
  go to Dann / Jotaroh and for the music to seablue.

  lesson6.cpp
  Cone3D GFX with SDL lesson 6.
  Made by Marius Andra 2001
  http://cone3d.gamedev.net

  You can use the code for anything you like.
  Even in a commercial project.
  But please let me know where it ends up.
  I'm just curious. That's all.
}

uses SysUtils,
     uMain;

function CheckSwitch(aName : String) : Boolean;
var
  Loop             : Integer;
  sParam           : String;
begin
  Result := False;
  aName   := UpperCase(aName);
  for Loop := 1 to ParamCount do begin
    sParam := UpperCase(ParamStr(Loop));
    if (Copy(sParam, 1, 1) <> '-') and (Copy(sParam, 1, 1) <> '/')
    then begin
      Continue;
    end else begin
      Delete(sParam, 1, 1);
    end;

    if (sParam = aName) then begin
      Result := True;
      Break;
    end;
  end;
end;

var
  Game             : TGameMain;
begin
  Game := TGameMain.Create('2D Sidescroller ported from Marius Andra, http://cone3d.gamedev.net');
  try
    Game.FullScreen := CheckSwitch('f') or CheckSwitch('fullscreen');
    Game.ShowCursor := False;
    Game.SetupVideo;
    Game.SetupAudio;
    Game.GameInit;
    Game.Run;
  finally
    FreeAndNil(Game);
  end;
end.

