program lesson4_2;
{$IFDEF FPC}
  {$MODE DELPHI}
{$ELSE}
  {$APPTYPE CONSOLE}
{$ENDIF}

uses
  dglOpenGL,
  easySDL,SDL,SDL_Image;

type
  TMyProgram=class(TEasySDL)
    x,y:single;
    texture : gluInt;
    
    procedure LoadTexture;
    
    procedure DrawScene;override;
    procedure UpdateWorld(Seconds: TGLFloat); override;
  end;

var
  MyProgram :TMyProgram;


procedure TMyProgram.LoadTexture;
var
  tex : PSDL_Surface;
begin
  tex := IMG_Load('../data/gfx/wall.jpg');
  if assigned(tex) then
  begin
    glGenTextures(1, @texture);
    glBindTexture(GL_TEXTURE_2D, texture);

    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

    // Achtung! Einige Bildformate erwarten statt GL_RGB, GL_BGR. Diese Konstante fehlt in den Standard-Headern
    glTexImage2D(GL_TEXTURE_2D, 0, 3, tex^.w, tex^.h,0, GL_RGB, GL_UNSIGNED_BYTE, tex^.pixels);

    SDL_FreeSurface(tex);
  end;
end;
procedure TMyProgram.UpdateWorld(Seconds: TGLFloat);
begin
  x:=x+1*Seconds;
  y:=y+0.1*Seconds;
end;

procedure TMyProgram.DrawScene;
begin
  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);

    // Wir verndern unsere Texture-Matrix
  glMatrixMode(GL_TEXTURE);
    glLoadIdentity;
    glTranslatef(x,y,0);
  glMatrixMode(GL_MODELVIEW); // Nicht vergessen den Matrix-Mode wieder zurck zu schalten

  glLoadIdentity;
  gltranslatef(0,0,-5);

  glBindTexture(GL_TEXTURE_2D,texture);
  glBegin(GL_QUADS);
    glTexCoord2f(0,0); glVertex3f(-1,-1,0);
    glTexCoord2f(0,1); glVertex3f(-1,1,0);
    glTexCoord2f(1,1); glVertex3f(1,1,0);
    glTexCoord2f(1,0); glVertex3f(1,-1,0);
  glEnd;
end;

begin
  MyProgram := TMyProgram.Create;

  MyProgram.Start;
  MyProgram.LoadTexture;
  MyProgram.Loop;
  MyProgram.Stop;
end.
