program lesson4_3;
{$IFDEF FPC}
  {$MODE DELPHI}
{$ELSE}
  {$APPTYPE CONSOLE}
{$ENDIF}

uses
  dglOpenGL,
  easySDL,SDL,SDL_Image;

type
  TMyProgram=class(TEasySDL)
    x,outrot:single;
    texture1 : gluInt;
    texture2 : gluInt;

    procedure LoadTextures;
    procedure DrawPyramid;
    
    procedure DrawScene;override;
    procedure UpdateWorld(Seconds: TGLFloat); override;
  end;

var
  MyProgram :TMyProgram;


procedure TMyProgram.LoadTextures;
var
  tex : PSDL_Surface;
begin
  tex := IMG_Load('../data/gfx/wall.jpg');
  if assigned(tex) then
  begin
    glGenTextures(1, @texture1);
    glBindTexture(GL_TEXTURE_2D, texture1);

    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

    // Achtung! Einige Bildformate erwarten statt GL_RGB, GL_BGR. Diese Konstante fehlt in den Standard-Headern
    glTexImage2D(GL_TEXTURE_2D, 0, 3, tex^.w, tex^.h,0, GL_RGB, GL_UNSIGNED_BYTE, tex^.pixels);

    SDL_FreeSurface(tex);
  end;
  tex := IMG_Load('../data/gfx/energy.jpg');
  if assigned(tex) then
  begin
    glGenTextures(1, @texture2);
    glBindTexture(GL_TEXTURE_2D, texture2);

    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

    // Achtung! Einige Bildformate erwarten statt GL_RGB, GL_BGR. Diese Konstante fehlt in den Standard-Headern
    glTexImage2D(GL_TEXTURE_2D, 0, 3, tex^.w, tex^.h,0, GL_RGB, GL_UNSIGNED_BYTE, tex^.pixels);

    SDL_FreeSurface(tex);
  end;

  
end;
procedure TMyProgram.UpdateWorld(Seconds: TGLFloat);
begin
// "Berechnung" der Szene
  x:=x+60*Seconds;
  outrot:=outrot+120*Seconds;
end;

procedure TMyProgram.DrawScene;
begin
  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);

  // Kleine Pyramide in der Mitte
  glBindTexture(GL_TEXTURE_2D,texture1);
  glLoadIdentity;
  glTranslatef(0,0,-14);

  glPushMatrix;
  glTranslatef(0,sin(x/50),0);
  glRotatef(x,0,1,0);

  glMatrixMode(GL_TEXTURE);
    glLoadIdentity;
    glColor3f(1,1,1);
    glTranslatef(0,-(x/100),0);
  glMatrixMode(GL_MODELVIEW);

  DrawPyramid;
  glPopMatrix;

  // Gre mittlere Pyramide
  glBindTexture(GL_TEXTURE_2D,texture2);

(*NEU! : Alpha blending aktivieren*)
  glEnable(GL_BLEND);                  // Aktivieren von Alpha Blending
  glBlendFunc(GL_SRC_ALPHA,GL_ONE);    // Definiert die Art, wie bergeblendet werden soll
  glDisable(GL_DEPTH_TEST);            // Z-Buffer deaktivieren

  glPushMatrix;
  glRotatef(x,0,1,0);
  glScalef(2,2,2);

  if Sin(x/50)<0.9 then glColor4f(1,1,1,0.4) else glColor4f(1,0.3,0.3,0.5);

  DrawPyramid;
  glPopMatrix;

  // Blaue uere Pyramide
  glPushMatrix;
  glColor4f(0.3,0.3,0.8,0.8);
  glRotatef(outrot,0,1,0);
  glTranslatef(5,0,0);
  glRotatef(outRot,-0.5,1,0);
  DrawPyramid;
  glPopMatrix;

  // Grne uere Pyramide
  glPushMatrix;
  glColor4f(0.3,0.8,0.3,0.8);
  glRotatef(outrot,0,1,0);
  glTranslatef(-5,0,0);
  glRotatef(OutRot,0.5,1,0);
  DrawPyramid;
  glPopMatrix;

(*NEU! : Alpha blending deaktivieren*)
    glDisable(GL_BLEND);                 // Alpha blending deaktivieren
    glEnable(GL_DEPTH_TEST);             // Z-Buffer an
end;

procedure TMyProgram.DrawPyramid;
begin
  glBegin(GL_TRIANGLES);
    //left
    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, -1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f(-1.0, -1.0,  1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f(   0,  1.0,    0);

    //right
    glTexCoord2f(0.0, 0.0); glVertex3f( 1.0, -1.0, -1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0,  1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f(   0,  1.0,    0);

    //front
    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0,  1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0,  1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f( 0.0,  1.0,  0.0);

    //back
    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, -1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0, -1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f( 0.0,  1.0,  0.0);
    glEnd;
END;

begin
  MyProgram := TMyProgram.Create;

  MyProgram.Start;
  MyProgram.LoadTextures;
  MyProgram.Loop;
  MyProgram.Stop;
end.
