program lesson4_4;
{$IFDEF FPC}
  {$MODE DELPHI}
{$ELSE}
  {$APPTYPE CONSOLE}
{$ENDIF}

uses
  dglOpenGL,
  easySDL,SDL,SDL_Image;

const
  MAP_WIDTH = 10;
  MAP_HIGHT = 30;

type
  TMyProgram=class(TEasySDL)
    z:single;
    texture : gluInt;
    MAP : array[0..MAP_WIDTH+1,0..MAP_HIGHT+1] of single;

    procedure InitMap;
    procedure LoadTextures;
    
    procedure DrawScene;override;
    procedure UpdateWorld(Seconds: TGLFloat); override;
  end;

var
  MyProgram :TMyProgram;
  
procedure TMyProgram.LoadTextures;
var
  tex : PSDL_Surface;
begin
  tex := IMG_Load('../data/gfx/venus.jpg');
  if assigned(tex) then
  begin
    glGenTextures(1, @texture);
    glBindTexture(GL_TEXTURE_2D, texture);

    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

    // Achtung! Einige Bildformate erwarten statt GL_RGB, GL_BGR. Diese Konstante fehlt in den Standard-Headern
    glTexImage2D(GL_TEXTURE_2D, 0, 3, tex^.w, tex^.h,0, GL_RGB, GL_UNSIGNED_BYTE, tex^.pixels);

    SDL_FreeSurface(tex);
  end;

end;
procedure TMyProgram.UpdateWorld(Seconds: TGLFloat);
begin
// "Berechnung" der Szene
  z:=z-0.8*Seconds;
end;

procedure TMyProgram.DrawScene;
var
  x,y: integer;
  u,v: single;
begin
  glClearColor(0.8,0.8,1,1);
  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);

  glLoadIdentity;
  gluLookAt((MAP_WIDTH/2),2,5,
            (MAP_WIDTH/2),2,0,
            0,1,0);
  glPushMatrix;
  u:=1/MAP_WIDTH;
  v:=1/MAP_HIGHT;
  glNormal3f( 0.0, 1.0, 0.0);
  
  glTranslatef(0,0,-z);
  
  for y:=0 to MAP_HIGHT-1 do
  begin
    glPushMatrix;
    for x:=0 to MAP_WIDTH-1 do
    begin
      glBegin(gl_QUADS);
        glTexCoord2f(u*x    , v*(y+1)); glVertex3f(0, map[x,y+1]  , 0);
        glTexCoord2f(u*x    , v*y    ); glVertex3f(0, map[x,y]    , 1);
        glTexCoord2f(u*(x+1), v*y    ); glVertex3f(1, map[x+1,y]  , 1);
        glTexCoord2f(u*(x+1), v*(y+1)); glVertex3f(1, map[x+1,y+1], 0);
      glEnd;
      glTranslatef(1,0,0);
    end;
    glPopMatrix;
    glTranslatef(0,0,-1);
  end;
  glPopMatrix;
end;

procedure TMyProgram.InitMap;
var
  x, y : integer;
begin
  randomize;
  for x:=0 to MAP_WIDTH+1 do
  for y:=0 to MAP_HIGHT+1 do
  Map[x,y]:=0.01*Random(50);
end;

begin
  MyProgram := TMyProgram.Create;

  MyProgram.Start;
  MyProgram.LoadTextures;
  MyProgram.InitMap;
  MyProgram.Loop;
  MyProgram.Stop;
end.
