program lesson4_5;
{$IFDEF FPC}
  {$MODE DELPHI}
{$ELSE}
  {$APPTYPE CONSOLE}
{$ENDIF}

uses
  dglOpenGL,
  easySDL,SDL,SDL_Image;

type
  TMyProgram=class(TEasySDL)
    pic:single;
    texture : gluInt;

    procedure LoadTextures;
    
    procedure DrawScene;override;
    procedure UpdateWorld(Seconds: TGLFloat); override;
  end;

var
  MyProgram :TMyProgram;
  
procedure TMyProgram.LoadTextures;
var
  tex : PSDL_Surface;
begin
  tex := IMG_Load('../data/gfx/numbers.jpg');
  if assigned(tex) then
  begin
    glGenTextures(1, @texture);
    glBindTexture(GL_TEXTURE_2D, texture);

    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

    // Achtung! Einige Bildformate erwarten statt GL_RGB, GL_BGR. Diese Konstante fehlt in den Standard-Headern
    glTexImage2D(GL_TEXTURE_2D, 0, 3, tex^.w, tex^.h,0, GL_RGB, GL_UNSIGNED_BYTE, tex^.pixels);

    SDL_FreeSurface(tex);
  end;
  // SDL laed standart gemaess texturen verkehrtherrum
  // Darum muessen wir sie noch umdrehen:
  glMatrixMode(GL_TEXTURE);
  glScalef(1,-1,1);
  glMatrixMode(GL_MODELVIEW);

end;
procedure TMyProgram.UpdateWorld(Seconds: TGLFloat);
begin
  pic:= pic+2*Seconds;      // Geschwindigkeit (in dem Fall Bilder pro Sekunde)
end;

procedure TMyProgram.DrawScene;
var
  s : single;
begin
  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);

  glLoadIdentity;
  glTranslatef(0,-2,-10);

  glBindTexture(GL_TEXTURE_2D,texture);     // Texture setzen


  s:=1/8;             { Berechnung der Bildgre. In diesem Fall besteht das Bild aus 8 Bildern,
                         beim UV-Mapping ist das Maximum 1, d.h. 1/8 = 0.125. D.h.
                         0 - 0.125      #Bild 1
                         0.125 - 0.250  #Bild 2
                         etc
                        }
                        

  { Wir berechnen das UV-Mapping jedesmal neu. Grob behalten wir immer die Gre 1/8, scrollen,
    die Texture, aber praktisch Schritt fr Schritt, so dass diese langsam auf dem Screen
    lngs scrollt}
  glBegin(GL_QUADS);
    glTexCoord2f(pic*s,1); glVertex3f(-1,1,0);
    glTexCoord2f(pic*s+s,1); glVertex3f(1,1,0);
    glTexCoord2f(pic*s+s,0); glVertex3f(1,-1,0);
    glTexCoord2f(pic*s,0); glVertex3f(-1,-1,0);
  glEnd;

  { Ein Interessantes Beispiel dafr, das die richtigen Zahlen sehr wichtig sein
    knnen. Wir runden unsere Werte hier einfach, d.h. wir erreichen nur volle Bildteiel
    1/8*x. Da x nur ganzzahlig ist, gibt es kein flssige Animation, sondern ein "umblenden".
   }

  glTranslatef(0,3,0);
  glBegin(GL_QUADS);
    glTexCoord2f(Round(pic)*s,1); glVertex3f(-1,1,0);
    glTexCoord2f(Round(pic)*s+s,1); glVertex3f(1,1,0);
    glTexCoord2f(Round(pic)*s+s,0); glVertex3f(1,-1,0);
    glTexCoord2f(Round(pic)*s,0); glVertex3f(-1,-1,0);
  glEnd;
end;


begin
  MyProgram := TMyProgram.Create;

  MyProgram.Start;
  MyProgram.LoadTextures;
  MyProgram.Loop;
  MyProgram.Stop;
end.
